// YtvUltraSoundMedScan0View.cpp : implementation of the CYtvScansView class
//

#include "stdafx.h"
#include "YtvServices.h"
#include "MainFrm.h"
#include "YtvScansDoc.h"
#include "YtvScansView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CYtvScansView

IMPLEMENT_DYNCREATE(CYtvScansView, CFormView)

BEGIN_MESSAGE_MAP(CYtvScansView, CFormView)
	//{{AFX_MSG_MAP(CYtvScansView)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	ON_COMMAND(ID_YTV_NEXT_SLIDE, OnYtvNextSlide)
	ON_COMMAND(ID_YTV_PREVIOUS_SLIDE, OnYtvPreviousSlide)
	ON_COMMAND(ID_YTV_EXPAND_CURSORS, OnYtvExpandCursors)
	ON_COMMAND(ID_YTV_MOVE_LEFT_CURSORS, OnYtvMoveLeftCursors)
	ON_COMMAND(ID_YTV_MOVE_RIGHT_CURSORS, OnYtvMoveRightCursors)
	ON_COMMAND(ID_YTV_COMPRESS_CURSORS, OnYtvCompressCursors)
	ON_COMMAND(ID_YTV_HELP0, OnYtvHelp0)
	//}}AFX_MSG_MAP
	// Standard printing commands
    ON_COMMAND(IDC_DB_NAME,OnDbName) 
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CYtvScansView construction/destruction

CYtvScansView::CYtvScansView()
:CFormView(CYtvScansView::IDD)
{
	//{{AFX_DATA_INIT(CYtvScansView)
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_bSizedBefore=FALSE;
	m_pPropSheet=NULL;
	m_prpDataBasePage=NULL;
    m_prpMesurePage=NULL;
    m_prpCalcPage=NULL;
    m_prpPrintPage=NULL; 
    m_prpExitPage=NULL;	
	m_hWndFocus = NULL;
	m_pInfo=NULL;


}

CYtvScansView::~CYtvScansView()
{
	delete m_pPropSheet;
	delete m_prpDataBasePage;
    delete m_prpMesurePage;
    delete m_prpCalcPage;
    delete m_prpPrintPage; 
    delete m_prpExitPage;
}

void CYtvScansView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CYtvScansView)
	//}}AFX_DATA_MAP
}

BOOL CYtvScansView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CYtvScansView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();
	//SetComPort();//YTV?
	ResizeParentToFit();

}


/////////////////////////////////////////////////////////////////////////////
// CYtvScansView printing

BOOL CYtvScansView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
    m_pInfo=pInfo;
	return DoPreparePrinting(pInfo);
}
/*
void CYtvScansView::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add extra initialization before printing
}

void CYtvScansView::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add cleanup after printing
}
void CYtvScansView::OnEndPrintPreview(CDC* pDC, CPrintInfo* pInfo, POINT point, CPreviewView* pView) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CFormView::OnEndPrintPreview(pDC, pInfo, point, pView);
}
void CYtvScansView::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
	// TODO: add customized printing code here
	CView::OnPrint(m_prpPrintPage->GetDC(), &m_prpPrintPage->m_struPrintInfo);
}
*/
/////////////////////////////////////////////////////////////////////////////
// CYtvScansView diagnostics

#ifdef _DEBUG
void CYtvScansView::AssertValid() const
{
	CFormView::AssertValid();
}

void CYtvScansView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CYtvScansDoc* CYtvScansView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CYtvScansDoc)));
	return (CYtvScansDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CYtvScansView message handlers

void CYtvScansView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	if (nType != SIZE_MINIMIZED && cx != 0 && cy != 0 && m_pPropSheet != NULL)
	{
		if (m_bSizedBefore == FALSE)
		{
			m_bSizedBefore = TRUE;

			// get the size of the property sheet
			CRect rectSized;
			m_pPropSheet->GetWindowRect(rectSized);

			// calculate the size of the frame
			CFrameWnd* pFrame = GetParentFrame();
			if (pFrame != NULL)
			{
				pFrame->CalcWindowRect(rectSized);
				CWnd* pParent = pFrame->GetParent();

				if (pParent != NULL)
					pParent->ScreenToClient(rectSized);

				// resize and reposition the frame
				pFrame->MoveWindow(rectSized);
			}
		}
	}
}

BOOL CYtvScansView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	if(!CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext))
		return FALSE;
	
	// TODO: Add your specialized code here and/or call the base class
		// add your pages here!

	m_prpDataBasePage=new DataBasePage;
	m_prpDataBasePage->m_pView=this;
    m_prpMesurePage=new MeasurementPage;
    m_prpCalcPage=new CCalculatorPage;
    m_prpPrintPage=new PrintPage; 
    m_prpExitPage=new ExitPage;
	// create the window object
    m_pPropSheet=new CYtvPropertySheet;
	m_pPropSheet->AddPage(m_prpDataBasePage);
	m_pPropSheet->AddPage(m_prpMesurePage);
	m_pPropSheet->AddPage(m_prpCalcPage);
	m_pPropSheet->AddPage(m_prpPrintPage);
	m_pPropSheet->AddPage(m_prpExitPage);
    m_prpDataBasePage->m_pPSh=m_pPropSheet;
	m_prpDataBasePage->m_pPPg=m_prpMesurePage;
	// create a modeless property page
	if (!m_pPropSheet->Create(this,
			DS_CONTEXTHELP | DS_SETFONT | WS_CHILD | WS_VISIBLE))
	{
		DestroyWindow();
		return FALSE;
	}

	m_pPropSheet->SetWindowPos(NULL, 0, 0, 0, 0,
			SWP_NOACTIVATE | SWP_NOZORDER | SWP_NOSIZE);
	// we use the style from the template - but make sure that
	// the WS_BORDER bit is correct.
	// the WS_BORDER bit will be whatever is in dwRequestedStyle
	m_pPropSheet->ModifyStyle(WS_BORDER|WS_CAPTION,
		dwStyle & (WS_BORDER|WS_CAPTION));

	// Force the size requested.
	// Fake a call to OnSize()--it would have been called automatically
	// if this were using the base class implementation of Create().

	CFrameWnd* pParentFrame = GetParentFrame();
	CRect rectSize;
	m_pPropSheet->GetWindowRect(rectSize);
	pParentFrame->CalcWindowRect(rectSize);
	OnSize(SIZE_RESTORED, rectSize.Width(), rectSize.Height());

	return TRUE;
	
}

BEGIN_EVENTSINK_MAP(CYtvScansView, CFormView)
    //{{AFX_EVENTSINK_MAP(CYtvScansView)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CYtvScansView::OnClose() 
{
	// TODO: Add your message handler code here and/or call default

	CFormView::OnClose();
}

void CYtvScansView::OnYtvNextSlide() 
{
	// TODO: Add your command handler code here
	m_prpMesurePage->OnYtvNextSlide();
}

void CYtvScansView::OnYtvPreviousSlide() 
{
	// TODO: Add your command handler code here
	m_prpMesurePage->OnYtvPreviousSlide();
}

void CYtvScansView::OnYtvExpandCursors() 
{
	// TODO: Add your command handler code here
	m_prpMesurePage->OnYtvExpandCursors();
}

void CYtvScansView::OnYtvMoveLeftCursors() 
{
	// TODO: Add your command handler code here
	m_prpMesurePage->OnYtvMoveLeftCursors();
}

void CYtvScansView::OnYtvMoveRightCursors() 
{
	// TODO: Add your command handler code here
	m_prpMesurePage->OnYtvMoveRightCursors();
}

void CYtvScansView::OnYtvCompressCursors() 
{
	// TODO: Add your command handler code here
	m_prpMesurePage->OnYtvCompressCursors();
}



void CYtvScansView::OnDraw(CDC* pDC) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(pDC->GetWindow() && pDC->GetWindow()->m_hWnd==m_hWnd)
		return;
	m_prpPrintPage->OnDraw(pDC,m_prpCalcPage,m_prpMesurePage,m_pInfo);	
}

void CYtvScansView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(bActivate && pActivateView==this)
    {
      ((CMainFrame*)AfxGetMainWnd())->SetPos();
    }
	CFormView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CYtvScansView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(lHint==IDC_DB_NAME)
	    m_prpDataBasePage->OnDbName();
	
}
void CYtvScansView::OnDbName()
{
   m_prpDataBasePage->OnDbName();
}

void CYtvScansView::OnYtvHelp0() 
{
	// TODO: Add your command handler code here
	m_prpExitPage->OnYtvHelp0();
}
